# Class PBMPanoFilter

监听者模式

#### Example

    new Subscribe<{
    "foo": [arg1: number, arg2: string],
    "bar": [arg: boolean],
    }>()

#### Hierarchy (View Summary)

- PBMUpdateable
  - PBMPanoFilter

- Defined in lib/five/model/materials/pbmMaterial.ts:103

##### Index

### Constructors

constructor

### Properties

color
contrast
highlightShadow
id
saturation

### Methods

emit
hasListener
off
on
once
toValue
waitUntil
computeLut

## Constructors

### constructor

- new PBMPanoFilter(): PBMPanoFilter

  #### Returns PBMPanoFilter

  Overrides PBMUpdateable.constructor

  - Defined in lib/five/model/materials/pbmMaterial.ts:202

## Properties

### `Readonly` color

color: { temperatureBias: number; tintBias: number }

颜色

#### Type Declaration

- ##### temperatureBias: number

  色温偏移 [-100, 100]

- ##### tintBias: number

  色調偏移 [-100, 100]

- Defined in lib/five/model/materials/pbmMaterial.ts:120

### `Readonly` contrast

contrast: { contrastBias: number }

对比度

#### Type Declaration

- ##### contrastBias: number

  对比偏移 [-1, 1]

- Defined in lib/five/model/materials/pbmMaterial.ts:108

### `Readonly` highlightShadow

highlightShadow: {
globalBias: number;
highlightBias: number;
lutMap: Texture;
shadowBias: number;
}

高光阴影

#### Type Declaration

- ##### globalBias: number

  全局亮度偏移 [-255, 255]

- ##### highlightBias: number

  高光偏移 [-255, 255]

- ##### `Readonly` lutMap: Texture

  高光阴影的颜色对照表

- ##### shadowBias: number

  阴影偏移 [-255, 255]

- Defined in lib/five/model/materials/pbmMaterial.ts:128

### `Readonly` id

id: string = ...

- Defined in lib/five/model/materials/pbmMaterial.ts:105

### `Readonly` saturation

saturation: { saturationBias: number }

饱和度

#### Type Declaration

- ##### saturationBias: number

  饱和偏移 [-1, 1]

- Defined in lib/five/model/materials/pbmMaterial.ts:114

## Methods

### emit

- emit<K extends "update">(
  name: K,
  ...data: Parameters<{ update: () => void }[K]>,
  ): boolean

  触发事件

  #### Type Parameters

  - K extends "update"

    预设的监听事件名称

  #### Parameters

  - name: K

    事件类型

  - ...data: Parameters<{ update: () => void }[K]>

    触发事件的数据

  #### Returns boolean

  canceled 是否被触发取消

  Inherited from PBMUpdateable.emit

  - Defined in lib/five/utils/subscribe.ts:131

### hasListener

- hasListener(name: "update"): boolean

  判断是否注册了事件

  #### Parameters

  - name: "update"

    事件类型

  #### Returns boolean

  Inherited from PBMUpdateable.hasListener

  - Defined in lib/five/utils/subscribe.ts:44

### off

- off<K extends "update">(
  name?: K,
  callback?: (
  ...args: Parameters<{ update: () => void }[K]>,
  ) => ReturnType<{ update: () => void }[K]>,
  ): void

  解除事件

  如果 name 不传的话解除对应所有事件 如果 name, callback 不传的话解除所有name的所有事件

  #### Type Parameters

  - K extends "update"

    预设的监听事件名称

  #### Parameters

  - `Optional` name: K

    事件类型

  - `Optional` callback: (
    ...args: Parameters<{ update: () => void }[K]>,
    ) => ReturnType<{ update: () => void }[K]>

    事件回调函数

  #### Returns void

  Inherited from PBMUpdateable.off

  - Defined in lib/five/utils/subscribe.ts:97

### on

- on<K extends "update">(
  name: K,
  callback: (
  this: this,
  ...args: Parameters<{ update: () => void }[K]>,
  ) => ReturnType<{ update: () => void }[K]>,
  once?: boolean,
  ): () => void

  注册事件

  #### Type Parameters

  - K extends "update"

    预设的监听事件名称

  #### Parameters

  - name: K

    事件类型

  - callback: (
    this: this,
    ...args: Parameters<{ update: () => void }[K]>,
    ) => ReturnType<{ update: () => void }[K]>

    事件回调函数

  - `Optional` once: boolean

    是否只执行一次

  #### Returns () => void

  解除事件

  Inherited from PBMUpdateable.on

  - Defined in lib/five/utils/subscribe.ts:58

### once

- once<K extends "update">(
  name: K,
  callback: (
  this: this,
  ...args: Parameters<{ update: () => void }[K]>,
  ) => ReturnType<{ update: () => void }[K]>,
  ): () => void

  注册事件(是否只执行一次)

  #### Type Parameters

  - K extends "update"

    预设的监听事件名称

  #### Parameters

  - name: K

    事件类型

  - callback: (
    this: this,
    ...args: Parameters<{ update: () => void }[K]>,
    ) => ReturnType<{ update: () => void }[K]>

    事件回调函数

  #### Returns () => void

  解除事件

  Inherited from PBMUpdateable.once

  - Defined in lib/five/utils/subscribe.ts:81

### toValue

- toValue(): PBMPanoFilterValue

  #### Returns PBMPanoFilterValue

  - Defined in lib/five/model/materials/pbmMaterial.ts:311

### waitUntil

- waitUntil<K extends "update">(
  name: K,
  filter?: (...args: Parameters<{ update: () => void }[K]>) => boolean | void,
  ): Promise<Parameters<{ update: () => void }[K]>>

  等待事件

  #### Type Parameters

  - K extends "update"

    预设的监听事件名称

  #### Parameters

  - name: K

    事件类型

  - `Optional` filter: (...args: Parameters<{ update: () => void }[K]>) => boolean | void

    事件类型

  #### Returns Promise<Parameters<{ update: () => void }[K]>>

  触发事件的数据

  Inherited from PBMUpdateable.waitUntil

  - Defined in lib/five/utils/subscribe.ts:155

### `Static` computeLut

- computeLut(
  highlightBias: number,
  shadowBias: number,
  globalBias: number,
  width?: number,
  itemSize?: number,
  target?: Float32Array<ArrayBufferLike>,
  offset?: number,
  ): Float32Array

  计算调色 LUT

  #### Parameters

  - highlightBias: number
  - shadowBias: number
  - globalBias: number
  - width: number = 1024
  - itemSize: number = 1
  - `Optional` target: Float32Array<ArrayBufferLike>
  - `Optional` offset: number

  #### Returns Float32Array

  - Defined in lib/five/model/materials/pbmMaterial.ts:140